#include "NativeCodes.h"
#include "ImageOperators.h"
#include "MarkerBasedAR.h"

JNIEXPORT jstring JNICALL Java_bme_ar_labs_lab01_NativeHolder_getJNIMessage
  (JNIEnv *env, jobject object)
{
   return env->NewStringUTF("Hello JNI AR WORLD");
}

using namespace cv;

JNIEXPORT void JNICALL Java_bme_ar_labs_lab01_NativeHolder_edgeDetect
    (JNIEnv* env, jobject object, jlong srcMatAddr, jlong dstMatAddr)
{
    Mat& srcMat  = *(Mat*)srcMatAddr;
    Mat& dstMat = *(Mat*)dstMatAddr;
    edgeDetect(srcMat, dstMat);
}

JNIEXPORT void JNICALL Java_bme_ar_labs_lab01_NativeHolder_placeImageToQuads
    (JNIEnv* env, jobject object, jlong srcMatAddr, jlong dstMatAddr, jlong dstImageAddr)
{
    Mat& srcMat  = *(Mat*)srcMatAddr;
    Mat& dstMat = *(Mat*)dstMatAddr;
    Mat& imgMat = *(Mat*)dstImageAddr;

    //Mat resized;
    //resize(srcMat, resized, Size(640, 480));
    Mat gray;
    //cvtColor(resized, gray, CV_BGR2GRAY);
    cvtColor(srcMat, gray, CV_BGRA2GRAY);

    Mat bw;
    performThreshold(gray, bw);

    // DEBUG: show thresholded image
    //cvtColor(bw,dstMat,CV_GRAY2BGRA);
    //return;
    // \DEBUG


    std::vector< std::vector<cv::Point> > contours;
    findContours(bw, contours, 100);

    std::vector< Marker > markers1;
    findMarkerQuads(contours, markers1, 1);

    std::vector< Marker > markers2;
    removeMarkerDuplicates(markers1, markers2);

    std::vector<cv::Mat> canonicalMarkers;
    removePerspective(gray, markers2, canonicalMarkers);

    dstMat = srcMat.clone();
    for (int i = 0; i < markers2.size(); ++i)
    		{
    			double m[3][3] = { 	{(double)canonicalMarkers[i].cols / imgMat.cols, 0, 0 },
    								{ 0, (double)canonicalMarkers[i].rows / imgMat.rows, 0 },
    								{ 0, 0, 1 }};
    			Mat M = Mat(3, 3, CV_64F, m);
    			M = markers2[i].perspMInv * M;
    			cv::Mat layer;
    			cv::warpPerspective(imgMat, layer, M, cv::Size(imgMat.cols, imgMat.rows));
    			for (int x = 0; x < dstMat.cols;++x)
    				for (int y = 0; y < dstMat.rows; ++y)
    				{
    					dstMat.at<cv::Vec3b>(y, x) = layer.at<cv::Vec3b>(y, x)[0] == 0 ? dstMat.at<cv::Vec3b>(y, x) : layer.at<cv::Vec3b>(y, x);
    				}
    		}
}
