package bme.ar.labs.mixedAR;

import android.content.Context;
import android.opengl.GLSurfaceView;
import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;


public class MainRenderer implements GLSurfaceView.Renderer{
    private Context context;
    protected FloatBuffer VB = null;
    public float rotAngle = 0;

    public MainRenderer(Context context) {
        this.context = context;
    }
    public void onSurfaceCreated(GL10 gl, EGLConfig config) {
        gl.glClearColor(0.0F, 0.0F, 0.0F, 0.0F);
        float[] VCoords = {
                -1.0F, -1.0F, 0.0F,
                1.0F, -1.0F, 0.0F,
                1.0F, 1.0F, 0.0F,
                -1.0F, -1.0F, 0.0F,
                1.0F, 1.0F, 0.0F,
                -1.0F, 1.0F, 0.0F };

        ByteBuffer vbb = ByteBuffer.allocateDirect(VCoords.length * 4);
        vbb.order(ByteOrder.nativeOrder());
        this.VB = vbb.asFloatBuffer();
        this.VB.put(VCoords);
        this.VB.position(0);

    }
    public void onDrawFrame(GL10 gl) {
        gl.glClear(gl.GL_COLOR_BUFFER_BIT | gl.GL_DEPTH_BUFFER_BIT );
        gl.glMatrixMode(gl.GL_MODELVIEW);
        gl.glLoadIdentity();
        gl.glTranslatef(0,0,-6);
        gl.glColor4f(1, 0, 0, 1);
        gl.glRotatef(rotAngle, 0, 1, 0);

        gl.glEnableClientState(gl.GL_VERTEX_ARRAY);
        gl.glVertexPointer(3, gl.GL_FLOAT, 0, this.VB);
        gl.glDrawArrays(gl.GL_TRIANGLES, 0, 6);
        gl.glDisableClientState(gl.GL_VERTEX_ARRAY);

        rotAngle += 2.5f;

    }
    public void onSurfaceChanged(GL10 gl, int width, int height) {
        gl.glViewport(0, 0, width, height);
        float ratio = (float) width / height;
        gl.glMatrixMode(gl.GL_PROJECTION);
        gl.glLoadIdentity();
        gl.glFrustumf(-ratio, ratio, -1, 1, 1.0f, 10);

    }
}
